//
//  ViewController.swift
//  TyranoPlayerFramework
//
//  Created by ShikemokuMK on 2016/11/29.
//  Copyright © 2016年 ShikemokuMK. All rights reserved.
//

import UIKit

class ViewController: UIViewController,UIWebViewDelegate {

    var webView: UIWebView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        
        UIApplication.sharedApplication().idleTimerDisabled = true

        // WebViewを生成する
        self.webView = self.createWebView()
        
        //UA設定
        let ua = webView.stringByEvaluatingJavaScriptFromString("navigator.userAgent")
        let add_ua = " tyranoplayer-ios"
        let insert_ua = ua! + add_ua
        
        let agentDict = ["UserAgent":insert_ua]
        NSUserDefaults.standardUserDefaults().registerDefaults(agentDict)

        
        // サブビューを追加する
        self.view.addSubview(self.webView!)
        
        let path = NSBundle.mainBundle().pathForResource("game/index", ofType: "html")
        
        var lineIndex = 1
        var html = ""
        
        var sav_files = [String]()
        
        let libraryDir = NSSearchPathForDirectoriesInDomains(NSSearchPathDirectory.LibraryDirectory, NSSearchPathDomainMask.UserDomainMask, true)[0] ;
        let destPath = libraryDir;
        
        //セーブファイルがある場合は読み込み。
        var save_text = ""
        do {
            
            let manager = NSFileManager.defaultManager()
            let list = try manager.contentsOfDirectoryAtPath(destPath)
            for path in list {
                
                if(path.containsString(".sav")){
                    sav_files.append(path)
                }
                
            }
            
            
        } catch {
            print("error")
        }
        
        if let data = NSData(contentsOfFile: path!){
            
            let str = String(NSString(data: data, encoding: NSUTF8StringEncoding)!)
            
            str.enumerateLines{
                line, stop in
                
                if line.containsString("</head>") {
                    
                    var targetURL = NSBundle.mainBundle().pathForResource("tyrano_player", ofType: "js");
                    html+="<script type='text/javascript' src='"+targetURL!+"' ></script>\n"
                    
                    html+="<script>window.player_base_path='';</script>\n"
                    html+="<script>window.tyrano_save={};</script>\n"
                    
                    do{
                        for file_path in sav_files {
                            
                            save_text = try String(contentsOfFile: destPath+"/"+file_path, encoding: NSUTF8StringEncoding)
                            
                            let key_str = file_path.stringByReplacingOccurrencesOfString(".sav", withString: "")
                            
                            html+="<script>window.tyrano_save['"+key_str+"']=\""+save_text+"\";</script>\n"
                        }
                        
                    }catch{
                        
                    }
                    
                }
                
                html += line + "\n"
                
                lineIndex += 1
                
            }
            
            
        }else{
            print("error ティラノゲームが適切に配置されていません");
        }
        
        //webviewの設定
        webView.delegate = self;
        webView.allowsInlineMediaPlayback = true
        webView.mediaPlaybackRequiresUserAction = false
        
        
        NSURLCache.sharedURLCache().removeAllCachedResponses()
        NSURLCache.sharedURLCache().diskCapacity = 0
        NSURLCache.sharedURLCache().memoryCapacity = 0
        
        let gestureToLeft = UISwipeGestureRecognizer(target: self, action: "backPlayer")
        gestureToLeft.direction = UISwipeGestureRecognizerDirection.Right
        //gestureToLeft.numberOfTouchesRequired = 1
        self.webView.addGestureRecognizer(gestureToLeft)
        
        
        var base_url = NSURL(string: path!)
        self.webView!.loadHTMLString(html, baseURL:base_url)
        
        
    }
    
    func createWebView() -> UIWebView {
        // UIWebViewのインスタンスを生成
        let _webView = UIWebView()
        
        // 全画面表示にする
        _webView.frame = self.view.bounds
        
        return _webView
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func backPlayer(){
        
        let alert: UIAlertController = UIAlertController(title: "タイトルへ戻る", message: "終了してよろしいですね？セーブしていない場合、進捗は破棄されます", preferredStyle:  UIAlertControllerStyle.Alert)
        
        let defaultAction: UIAlertAction = UIAlertAction(title: "はい", style: UIAlertActionStyle.Default, handler:{
            // ボタンが押された時の処理を書く（クロージャ実装）
            (action: UIAlertAction!) -> Void in
            
            self.loadView()
            self.viewDidLoad()
            
        })
        
        // キャンセルボタン
        let cancelAction: UIAlertAction = UIAlertAction(title: "キャンセル", style: UIAlertActionStyle.Cancel, handler:{
            // ボタンが押された時の処理を書く（クロージャ実装）
            (action: UIAlertAction!) -> Void in
            print("Cancel")
        })
        
        // ③ UIAlertControllerにActionを追加
        alert.addAction(cancelAction)
        alert.addAction(defaultAction)
        
        // ④ Alertを表示
        presentViewController(alert, animated: true, completion: nil)
        
        
    }
    
    let kSchemeSave = "tyranoplayer-save://";
    
    func webView(webView: UIWebView, shouldStartLoadWithRequest request: NSURLRequest, navigationType: UIWebViewNavigationType) -> Bool {
        if let url = request.URL?.absoluteString {
            if url.hasPrefix(kSchemeSave) {
                
                print ("SAVE")
                
                var json_str = url.substringFromIndex(url.rangeOfString(kSchemeSave)!.endIndex)
                
                
                let array_str = json_str.componentsSeparatedByString("&")
                
                
                let json_str_key = array_str[0].stringByReplacingOccurrencesOfString("?key=", withString: "")
                let json_str_val = array_str[1].stringByReplacingOccurrencesOfString("data=", withString: "")
                
                
                do {
                    
                    let libraryDir = NSSearchPathForDirectoriesInDomains(NSSearchPathDirectory.LibraryDirectory, NSSearchPathDomainMask.UserDomainMask, true)[0];
                    
                    let destPath = libraryDir;//展開するディレクトリのパス
                    
                    let filePath = destPath+"/"+json_str_key+".sav"
                    
                    
                    print("SAVEPATH:"+filePath);
                    print("\n---------------------------\n");
                    
                    try json_str_val.writeToFile(filePath, atomically: true, encoding: NSUTF8StringEncoding)
                    
                    
                } catch {
                    print("EEEEEEEEEEEEEEE")
                    //print(localizedDescription)
                }
                
                
            }else if(url.hasPrefix("tyranoplayer-back://")){
                
                backPlayer();
                
            }
        }
        return true
    }

    override func prefersStatusBarHidden() -> Bool {
        return true
    }



}

